import java.io.*;

public class PermutationTest
{
	static String [] words = new String[183];
	public static void main(String[]args)
	{
		
		String entry;
		int arrindex = 0;
		try
		{
			BufferedReader br = new BufferedReader(new FileReader("finalconvert.txt"));
			while ( (entry = br.readLine() ) != null)
			{
				words[arrindex] = entry;
				arrindex++;					
			}
			br.close();
		}
			catch(IOException exc)
		{
			System.out.println("Failed to open or read data from file.");
		}
				
		
		int[] indices;
		String word;
		String word1=null;
		String word2=null;
		String word3=null;
		String word4=null;
		String word5=null;
		String word6=null;
		String word7=null;
		String word8=null;
		char [] charWord;
		int perms = numPerms(10);
		int percentPerms = perms/20;
		
		String[] elements = {"a", "n", "a","l","o","g","i","e","s","k" };
		PermutationGenerator x = new PermutationGenerator (elements.length);
		StringBuffer permutation;
		long startTime = System.currentTimeMillis();
		int sofar = 0;
		int percent = 5;
		while (x.hasMore ()) {
		sofar++;
		if(sofar == percentPerms)
		{
			System.out.println(percent + "% of all permutations computed...");
			percent= percent +5;
			sofar=0;
		}
		  
		  permutation = new StringBuffer ();
		  indices = x.getNext ();
		  for (int i = 0; i < indices.length; i++) {
		    permutation.append (elements[indices[i]]);
		  }
		  charWord = permutation.toString().toCharArray();
		  if(charWord[6] == 'a')
		  {
		  	word1 = ""+charWord[0] + charWord[1] + charWord[3]+charWord[6];
		  	word2 = ""+charWord[0] + charWord[1] + charWord[3]+charWord[7];
		  	word3= ""+charWord[0] + charWord[1] + charWord[4] + charWord[7];
		  	word4 = "" + charWord[0] + charWord[1] + charWord[4] + charWord[8];
		  	word5= "" + charWord[0] + charWord[2] + charWord[4] + charWord[7];
		  	word6= "" + charWord[0] + charWord[2] + charWord[4] + charWord[8];
		  	word7 = "" + charWord[0] + charWord[2] + charWord[5] + charWord[8];
		  	word8= "" + charWord[0] + charWord[2] + charWord[5] + charWord[9];
		  	if(isWord(word1)&&isWord(word2)&&isWord(word3)&&isWord(word4)&&isWord(word5)&&isWord(word6)
		  		&&isWord(word7)&&isWord(word8))
		  		{
		  			System.out.println("FOUND!!!");
		  			System.out.println("    " + charWord[0]);
		  			System.out.println("  "+charWord[1] + "  " +charWord[2]);
		  			System.out.println(" "+charWord[3]+"  " +charWord[4]+"  "+charWord[5]);
		  			System.out.println(charWord[6] + "  " +charWord[7] + "  " +charWord[8] + "  " + charWord[9]);
		  			System.out.println("Total Running time: ");
		  			System.out.println(((System.currentTimeMillis()-startTime)/1000)+ " seconds");
		  			break;
		  		}
		  }
		
	  	
		}
	}
	
	
	public static boolean isWord(String word)
	{
		
		boolean found = false;
		int counter = 0;
		while(counter < words.length)
		{
			if(word.compareToIgnoreCase(words[counter])==0)
			{
				found = true;
				break;
			}
			
			counter++;
		}
		return found;
	}
	
	public static int numPerms(int x)
	{
		int y = x;
		while(x>1)
		{
			x--;
			y = y * x;
		}
		return y;
	}
	
}
